//+------------------------------------------------------------------+
//|                                              VolatilityPivot.mq5 |
//|                                         Copyright  2005, S.B.T. |
//|                                                 excelf@gmail.com |
//+------------------------------------------------------------------+
//---  
#property copyright "Copyright  2005, S.B.T."
//---    
#property link "excelf@gmail.com"
//---   
#property version   "1.00"
//---     
#property indicator_chart_window
//---       4 
#property indicator_buffers 4
//---  4  
#property indicator_plots   4
//+----------------------------------------------+
//|           |
//+----------------------------------------------+
//---   1   
#property indicator_type1   DRAW_LINE
//---       Blue 
#property indicator_color1  clrBlue
//---   1 - -
#property indicator_style1  STYLE_DASHDOTDOT
//---    1  2
#property indicator_width1  2
//---    
#property indicator_label1  "Upper VolatilityPivot"
//+----------------------------------------------+
//|        |
//+----------------------------------------------+
//---   2   
#property indicator_type2   DRAW_LINE
//---        HotPink
#property indicator_color2  clrHotPink
//---   2 - -
#property indicator_style2  STYLE_DASHDOTDOT
//---    2  2
#property indicator_width2  2
//---    
#property indicator_label2  "Lower VolatilityPivot"
//+----------------------------------------------+
//|           |
//+----------------------------------------------+
//---   3   
#property indicator_type3   DRAW_ARROW
//---       DeepSkyBlue
#property indicator_color3  clrDeepSkyBlue
//---   3  4
#property indicator_width3  4
//---   
#property indicator_label3  "Buy VolatilityPivot"
//+----------------------------------------------+
//|        |
//+----------------------------------------------+
//---   4   
#property indicator_type4   DRAW_ARROW
//---       Red
#property indicator_color4  clrRed
//---   4  4
#property indicator_width4  4
//---   
#property indicator_label4  "Sell VolatilityPivot"
//+----------------------------------------------+
//|                            |
//+----------------------------------------------+
#define RESET 0  //        
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
enum Mode_
  {
   Mode_ATR=0,   //ATR
   Mode_Price    // 
  };
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input uint   atr_range=100;
input uint   ima_range=10;
input double atr_factor=3;
input Mode_  Mode=Mode_ATR;
input  uint  DeltaPrice=200;
input int    Shift=0;          //      
//+----------------------------------------------+
//---   ,   
//---      
double ExtMapBufferUp[];
double ExtMapBufferDown[];
double ExtMapBufferUp1[];
double ExtMapBufferDown1[];
//---
double dDeltaPrice;
//---      
int ATR_Handle;
//---      
int min_rates_total;
//+------------------------------------------------------------------+
//|   CMoving_Average                                  |
//+------------------------------------------------------------------+
#include <SmoothAlgorithms.mqh>
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+  
int OnInit()
  {
//---    ATR
   if(Mode==Mode_ATR)
     {
      min_rates_total=int(atr_range+ima_range)+1;
      ATR_Handle=iATR(NULL,0,atr_range);
      if(ATR_Handle==INVALID_HANDLE)
        {
         Print("      ATR");
         return(INIT_FAILED);
        }
     }
   else
     {
      min_rates_total=3;
      dDeltaPrice=DeltaPrice*_Point;
     }
//---    ExtMapBufferUp[]   
   SetIndexBuffer(0,ExtMapBufferUp,INDICATOR_DATA);
//---    1    Shift
   PlotIndexSetInteger(0,PLOT_SHIFT,Shift);
//---       1
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//---    ,      
   ArraySetAsSeries(ExtMapBufferUp,true);
//---   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---    ExtMapBufferDown[]   
   SetIndexBuffer(1,ExtMapBufferDown,INDICATOR_DATA);
//---    2    Shift
   PlotIndexSetInteger(1,PLOT_SHIFT,Shift);
//---       2
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//---    ,      
   ArraySetAsSeries(ExtMapBufferDown,true);
//---   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---    ExtMapBufferUp1[]   
   SetIndexBuffer(2,ExtMapBufferUp1,INDICATOR_DATA);
//---    1    Shift
   PlotIndexSetInteger(2,PLOT_SHIFT,Shift);
//---       3
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,min_rates_total);
//---    ,      
   ArraySetAsSeries(ExtMapBufferUp1,true);
//---   ,      
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---   
   PlotIndexSetInteger(2,PLOT_ARROW,118);
//---    ExtMapBufferDown1[]   
   SetIndexBuffer(3,ExtMapBufferDown1,INDICATOR_DATA);
//---    2    Shift
   PlotIndexSetInteger(3,PLOT_SHIFT,Shift);
//---       4
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,min_rates_total);
//---    ,      
   ArraySetAsSeries(ExtMapBufferDown1,true);
//---   ,      
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---   
   PlotIndexSetInteger(3,PLOT_ARROW,118);
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,"VolatilityPivot");
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
//---  
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double& high[],     //       
                const double& low[],      //        
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if((BarsCalculated(ATR_Handle)<rates_total && Mode==Mode_ATR) || rates_total<min_rates_total) return(RESET);
//---    
   double DeltaStop,Stop;
   static double PrevStop;
   int limit,bar;
//---    ,     
   ArraySetAsSeries(close,true);
//---    limit    
   if(prev_calculated>rates_total || prev_calculated<=0) //      
     {
      limit=rates_total-min_rates_total-1;               //      
      PrevStop=close[limit+1];
     }
   else limit=rates_total-prev_calculated;               //      
//---
   if(Mode==Mode_Price)
     {
      //---    
      for(bar=limit; bar>=0; bar--)
        {
         ExtMapBufferUp1[bar]=EMPTY_VALUE;
         ExtMapBufferDown1[bar]=EMPTY_VALUE;
         DeltaStop=dDeltaPrice;
         //---
         if(close[bar]==PrevStop) Stop=PrevStop;
         else
           {
            if(close[bar+1]<PrevStop && close[bar]<PrevStop) Stop=MathMin(PrevStop,close[bar]+DeltaStop);
            else
              {
               if(close[bar+1]>PrevStop && close[bar]>PrevStop) Stop=MathMax(PrevStop,close[bar]-DeltaStop);
               else
                 {
                  if(close[bar]>PrevStop) Stop=close[bar]-DeltaStop;
                  else Stop=close[bar]+DeltaStop;
                 }
              }
           }
         //---
         if(close[bar]>Stop) ExtMapBufferUp[bar]=Stop; else ExtMapBufferUp[bar]=EMPTY_VALUE;
         if(close[bar]<Stop) ExtMapBufferDown[bar]=Stop; else ExtMapBufferDown[bar]=EMPTY_VALUE;
         if(ExtMapBufferUp[bar+1]==EMPTY_VALUE && ExtMapBufferUp[bar]!=EMPTY_VALUE) ExtMapBufferUp1[bar]=ExtMapBufferUp[bar];
         if(ExtMapBufferDown[bar+1]==EMPTY_VALUE && ExtMapBufferDown[bar]!=EMPTY_VALUE) ExtMapBufferDown1[bar]=ExtMapBufferDown[bar];
         if(bar) PrevStop=Stop;
        }
     }
//---
   if(Mode==Mode_ATR)
     {
      //---    
      double ATR[];
      int to_copy,maxbar;
      //---    CMoving_Average   SmoothAlgorithms.mqh 
      static CMoving_Average EMA;
      //---    ,     
      ArraySetAsSeries(ATR,true);
      to_copy=limit+1;
      if(CopyBuffer(ATR_Handle,0,0,to_copy,ATR)<=0) return(RESET);
      maxbar=rates_total-min_rates_total-1;
      //---    
      for(bar=limit; bar>=0; bar--)
        {
         ExtMapBufferUp1[bar]=EMPTY_VALUE;
         ExtMapBufferDown1[bar]=EMPTY_VALUE;
         DeltaStop=atr_factor*EMA.EMASeries(maxbar,prev_calculated,rates_total,ima_range,ATR[bar],bar,true);
         //---
         if(close[bar]==PrevStop) Stop=PrevStop;
         else
           {
            if(close[bar+1]<PrevStop && close[bar]<PrevStop) Stop=MathMin(PrevStop,close[bar]+DeltaStop);
            else
              {
               if(close[bar+1]>PrevStop && close[bar]>PrevStop) Stop=MathMax(PrevStop,close[bar]-DeltaStop);
               else
                 {
                  if(close[bar]>PrevStop) Stop=close[bar]-DeltaStop;
                  else Stop=close[bar]+DeltaStop;
                 }
              }
           }
         //---
         if(close[bar]>Stop) ExtMapBufferUp[bar]=Stop; else ExtMapBufferUp[bar]=EMPTY_VALUE;
         if(close[bar]<Stop) ExtMapBufferDown[bar]=Stop; else ExtMapBufferDown[bar]=EMPTY_VALUE;
         //---
         if(ExtMapBufferUp[bar+1]==EMPTY_VALUE && ExtMapBufferUp[bar]!=EMPTY_VALUE) ExtMapBufferUp1[bar]=ExtMapBufferUp[bar];
         if(ExtMapBufferDown[bar+1]==EMPTY_VALUE && ExtMapBufferDown[bar]!=EMPTY_VALUE) ExtMapBufferDown1[bar]=ExtMapBufferDown[bar];
         //---
         if(bar) PrevStop=Stop;
        }
     }
//---     
   return(rates_total);
  }
//+------------------------------------------------------------------+
